
/*
 * DataStore for local files.
 *
 * Proxy URL depends on application's configuration settings.
 */

Ext.define('POSync.store.LocalFiles', {
    extend:     'Ext.data.TreeStore',
    requires:   'POSync.model.LocalFile',
    model:      'POSync.model.LocalFile',
    
    isLoaded:   null,                   // ID of project loaded
    
    root: {
        expanded: true,
        children: []
    },

    /* Load the store with the specified tree */
    loadTree: function (tree) {
        var proxy = this.getProxy();
        proxy.data = tree;
        this.load();
    },

    /**
     * Check if a file with the given path exists
     */
    searchUsingPathArray: function(pathArray) {
        var me = this;
        var root = me.getRootNode();
        // console.log(root);

        // Iterate through the pathArray elements from 
        // the top to find the file in the local folder
        var node = root;
        for (var i = 0; i < pathArray.length; i++) {
                var path = pathArray[i];
                // Check all children
                var child = null;
                var children = node.children;
                if (!children) return null;
                for (var j = 0; j < children.length; j++) {
                        var childName = children[j].get('name');
                        if (path == childName) {
                                child = children[j];
                        }
                }
                
                if (!child) return null;
                node = child;
        }
    
    }
    
});
